Clone Blueprint

Purpose

To clone a Blueprint in your Zoho CRM organization.

Endpoints

  • POST /settings/blueprints/{blueprint_ID}/actions/clone

Request Details

Request URL

{api-domain}/crm/{version}/settings/blueprints/{blueprint_ID}/actions/clone

Header

Authorization: Zoho-oauthtoken d92d4xxxxxxxxxxxxx15f52

Scope

ZohoCRM.settings.blueprint.CREATE  (or)
ZohoCRM.settings.blueprint.ALL  (or)
ZohoCRM.settings.ALL

Sample Request

Copiedcurl "https://www.zohoapis.com/crm/v8/settings/blueprints/5843104000000426851/actions/clone"
-X POST
-d "@input.json"
-H "Authorization: Zoho-oauthtoken 1000.8cb99dxxxxxxxxxxxxx9be93.9b8xxxxxxxxxxxxxxxf"

Input JSON

The blueprints JSON array must contain the details of the Blueprint cloning. It must include the following keys:

  • nametext, mandatory

    Provide the name of the cloned Blueprint.

  • typetext, mandatory

    Specify the type of cloning to be done for the Blueprint, such as standalone or dependent.

  • layoutJSON object, mandatory

    Specify the layout data of the cloned Blueprint.

    • idbigint

      Specify the layout ID of the cloned Blueprint.

    • nametext

      Specify the layout name of the cloned Blueprint.

  • fieldJSON object, mandatory

    Specify the field data of the cloned Blueprint.

    • idbigint

      Specify the field ID of the cloned Blueprint.

    • api_nametext

      Specify the field API name of the cloned Blueprint.

  • pipelineJSON object

    Specify the pipeline data of the cloned Blueprint.

    • idbigint

      Specify the pipeline ID of the cloned Blueprint.

    • nametext

      Specify the pipeline name of the cloned Blueprint.

  • map_statesJSON array

    Specify the mapping of states from the existing Blueprint to the cloned Blueprint.

  • existing_stateJSON object

    Specify the existing state data of the source Blueprint.

  • actual_valuetext

    Specify the actual value of the existing state.

  • clone_stateJSON object

    Specify the new state data for the cloned Blueprint.

  • actual_valuetext

    Specify the actual value of the cloned state.

  • moduletext, mandatory

    Specify the module API name of the cloned Blueprint.

Sample Input

Copied{
    "blueprints": [
        {
            "name": "Autonum_Cloned",
            "type": "standalone",
            "layout": {
                "id": "5843104000008502160",
                "name": "Standard"
            },
            "field": {
                "id": "5226917000000002565",
                "api_name": "Stage"
            },
            "pipeline": {
                "id": "5226917000004004001",
                "name": "Standard (Standard)"
            },
            "map_states": [
                {
                    "existing_state": {
                        "actual_value": "Value Proposition"
                    },
                    "clone_state": {
                        "actual_value": "Value Proposition"
                    }
                },
                {
                    "existing_state": {
                        "actual_value": "Needs Analysis"
                    },
                    "clone_state": {
                        "actual_value": "Needs Analysis"
                    }
                }
            ],
            "module": "Deals"
        }
    ]
}

Possible Errors

  • LIMIT_EXCEEDEDHTTP 400

    Blueprint limit exceeded.
    Resolution: Reduce the number of blueprints in the account or remove unused blueprints before cloning.

  • DUPLICATE_DATAHTTP 400

    There is already a blueprint with this name.
    Resolution: Specify a unique name for the cloned blueprint.

  • INVALID_DATAHTTP 400

    The ID given seems to be invalid.
    Resolution: Specify a valid blueprint ID in the request URL.

  • INVALID_DATAHTTP 400

    The given layout should be different from the source blueprint layout.
    Resolution: Specify a different layout ID for the cloned blueprint.

  • AMBIGUITY_DURING_PROCESSINGHTTP 400

    Ambiguity while processing the request because type is draft and map_states is also provided.
    Resolution: Do not provide map_states when the clone type is draft.

  • AMBIGUITY_DURING_PROCESSINGHTTP 400

    Ambiguity while processing the request because type is draft and a different layout.id is provided.
    Resolution: Do not provide a different layout ID when the clone type is draft.

  • AMBIGUITY_DURING_PROCESSINGHTTP 400

    Ambiguity while processing the request because type is draft and a different field.id is provided.
    Resolution: Do not provide a different field ID when the clone type is draft.

  • AMBIGUITY_DURING_PROCESSINGHTTP 400

    Ambiguity while processing the request because type is draft and a different pipeline.id is provided.
    Resolution: Do not provide a different pipeline ID when the clone type is draft.

  • AMBIGUITY_DURING_PROCESSINGHTTP 400

    Ambiguity while processing the request because type is draft and a different module name is provided.
    Resolution: Do not provide a different module name when the clone type is draft.

Sample Response

Copied{
    "blueprints": [
        {
            "code": "SUCCESS",
            "details": {
                "uncopied_before_criteria_fields": null,
                "id": "5843104000000426801",
                "uncopied_entry_criteria_fields": null,
                "uncopied_during_transition_fields": null
            },
            "message": "Blueprint successfully cloned",
            "status": "success"
        }
    ]
}